include string.inc
include fblk.inc
include dos.inc
include wsub.inc

wcount  equ <[bp-2]>

	.code

WSSORT_XCHG:
	mov	cx,2
	mov	bx,di
	shl	bx,cl
	mov	ax,wcount
	shl	ax,cl
	mov	cx,ax
ifdef __3__
	mov	eax,[si+bx]
	add	bx,cx
	mov	edx,[si+bx]
	mov	[si+bx],eax
	sub	bx,cx
	mov	[si+bx],edx
else
	mov	ax,[si+bx]
	mov	dx,[si+bx+2]
	add	bx,cx
	xchg	ax,[si+bx]
	xchg	dx,[si+bx+2]
	sub	bx,cx
	mov	[si+bx],ax
	mov	[si+bx+2],dx
endif
	ret

WSSORT_NAMEA:
	mov	bx,di

WSSORT_NAMEAB:
	shl	bx,2
ifdef __16__
	mov	ax,[si+bx]
	mov	dx,[si+bx+2]
else
	mov	eax,[si+bx]
endif
	add	ax,S_FBLK.fb_name
	ret

pusheax? macro
ifdef __16__
	push	dx
	push	ax
else
	push	eax
endif
	endm

WSSORT_NAMEB:
	mov	bx,wcount
	add	bx,di
	jmp	WSSORT_NAMEAB

WSSORT_UPDIR:
	call	WSSORT_NAMEA
	mov	bx,offset cp_dotdot
ifdef __16__
	invoke  stricmp,dx::ax,ss::bx
else
	invoke  stricmp,eax,ss::bx
endif
	ret

WSSORT_SUBDIR:
	mov	bx,di
	mov	cx,2
	shl	bx,cl
	les	bx,[si+bx]
	mov	ax,es:[bx]
	mov	bx,wcount
	add	bx,di
	shl	bx,cl
	les	bx,[si+bx]
	mov	dx,es:[bx]
	and	dx,_A_SUBDIR
	and	ax,_A_SUBDIR
	jz	CMPSUBD_01
	test	dx,dx
	jz	CMPSUBD_02
    CMPSUBD_00:
	or	al,1
	ret
    CMPSUBD_01:
	test	dx,dx
	jz	CMPSUBD_00
	call	WSSORT_XCHG
    CMPSUBD_02:
	xor	ax,ax
	ret

WSSORT_NAME:
ifdef __CDECL__
	call	WSSORT_NAMEB
	pusheax?
	call	WSSORT_NAMEA
else
	call	WSSORT_NAMEA
	pusheax?
	call	WSSORT_NAMEB
endif
	pusheax?
	call stricmp
	ret

WSSORT_DATE:
	mov	bx,di
	mov	cx,2
	shl	bx,cl
	les	bx,[si+bx]
	lodm	es:[bx].S_FBLK.fb_time
	mov	bx,wcount
	add	bx,di
	shl	bx,cl
	les	bx,[si+bx]
	cmp	dx,word ptr es:[bx].S_FBLK.fb_time+2
	jne	@F
	cmp	ax,word ptr es:[bx].S_FBLK.fb_time
      @@:
	ret

WSSORT_SIZE:
	mov	bx,di
	mov	cl,2
	shl	bx,cl
	les	bx,[si+bx]
ifdef __3__
	mov	eax,es:[bx].S_FBLK.fb_size
else
	lodm	es:[bx].S_FBLK.fb_size
endif
	mov	bx,wcount
	add	bx,di
	shl	bx,cl
	les	bx,[si+bx]
ifdef __3__
	cmp	eax,es:[bx].S_FBLK.fb_size
else
	cmp	dx,word ptr es:[bx].S_FBLK.fb_size+2
	jne	@F
	cmp	ax,word ptr es:[bx].S_FBLK.fb_size
      @@:
endif
	ret

WSSORT_TYPE:
	call	WSSORT_NAMEB
ifdef __3__
	invoke  strrchr,eax,'.'
	push	dx
	push	ax
	call	WSSORT_NAMEA
	invoke  strrchr,eax,'.'
else
	invoke  strrchr,dx::ax,'.'
	pusheax?
	call	WSSORT_NAMEA
	invoke  strrchr,dx::ax,'.'
endif
	pop	cx
	pop	bx
	jnz	WSSORT_TYPE_01
	test	cx,cx
	jz	WSSORT_TYPE_03
	dec	ax
    WSSORT_TYPE_00:
	test	ax,ax
	ret
    WSSORT_TYPE_01:
	test	bx,bx
	jnz	WSSORT_TYPE_03
	mov	ax,1
	jmp	WSSORT_TYPE_00
    WSSORT_TYPE_03:
	invoke  stricmp,dx::ax,bx::cx
	jmp	WSSORT_TYPE_00

wssortfcb proc _CType private uses si di fcb:dword, count:size_t, flag:size_t
local	half:size_t
	push	ds
	lds	si,fcb
	mov	ax,count
	shr	ax,1
    wssortfcb_00:
	mov	half,ax
	test	ax,ax
	jz	wssortfcb_11
	mov	word ptr fcb,ax
    wssortfcb_01:
	mov	ax,word ptr fcb
	cmp	ax,count
	jae	wssortfcb_10
	mov	di,ax
	sub	di,half
    wssortfcb_02:
	cmp	di,0
	jl	wssortfcb_09
	call	WSSORT_UPDIR
	jz	wssortfcb_09
	call	WSSORT_SUBDIR
	jz	wssortfcb_05
	mov	ax,flag
	test	dx,dx
	jz	wssortfcb_12
	test	ax,_W_SORTSUB
	jz	wssortfcb_03
    wssortfcb_12:
	and	ax,_W_SORTSIZE
	cmp	ax,_W_SORTTYPE
	je	wssortfcb_08
	cmp	ax,_W_SORTDATE
	je	wssortfcb_07
	cmp	ax,_W_SORTSIZE
	je	wssortfcb_06
    wssortfcb_03:
	call	WSSORT_NAME
	jl	wssortfcb_09
    wssortfcb_04:
	call	WSSORT_XCHG
    wssortfcb_05:
	sub	di,half
	jmp	wssortfcb_02
    wssortfcb_06:
	call	WSSORT_SIZE
	je	wssortfcb_03
	jb	wssortfcb_04
	jmp	wssortfcb_09
    wssortfcb_07:
	call	WSSORT_DATE
	je	wssortfcb_03
	jb	wssortfcb_04
	jmp	wssortfcb_09
    wssortfcb_08:
	call	WSSORT_TYPE
	jg	wssortfcb_04
	jnl	wssortfcb_03
    wssortfcb_09:
	inc	word ptr fcb
	jmp	wssortfcb_01
    wssortfcb_10:
	mov	ax,half
	shr	ax,1
	jmp	wssortfcb_00
    wssortfcb_11:
	pop	ds
	ret
wssortfcb endp

wssort  proc _CType public wsub:dword
	push	bx
	les	bx,wsub
	cmp	es:[bx].S_WSUB.ws_count,2
	jl	@F
	les	bx,es:[bx].S_WSUB.ws_flag
	mov	cx,es:[bx]
	les	bx,wsub
	invoke  wssortfcb,es:[bx].S_WSUB.ws_fcb,es:[bx].S_WSUB.ws_count,cx
      @@:
	pop	bx
	ret
wssort  endp

	END
